<?php
# DAT->TXT converter
# Version 0.8 2004/10/28

require_once('functions.php');
require_once('dec_header.php');
$ver=0;
$cont=0;
$apdnb=0;

$start_time = microtime(true);
file_exists($datfile) or die("File DAT '$datfile' doesn't exists.");
$datp = fopen($datfile,'rb');
$txtp = fopen($txtfile.'.txt','wt');
$heap='';
$header and ($heap = fopen($txtfile . '-header.txt','wt'));
$verp='';
$verbose and ($verp = fopen($txtfile . '.log','wt'));

$stats = fstat($datp);

#test preliminaire :
$test = fread($datp,20);
(substr(rtrim($test),0,9)=='HP4155_C0') or die($datfile . " is not an HP415x DAT file. '" . substr(rtrim($test),0,12) . "'");
#(substr(rtrim($test),9,4)=='1.02') and (print "This file was made from a 4155A\n" and $ver=0);
#(substr(rtrim($test),9,4)=='1.04') and (print "This file was made from a 4156A\n" and $ver=0);
#(substr(rtrim($test),9,4)=='3.04') and (print "This file was made from a 4156C\n" and $ver=1);
fseek($datp,0);
$preambule = dec_preambule( fread($datp,  114));
$header and out($heap,print_r($preambule,true),$onscreen);
$chDefSetup = dec_chDefSetup(fread($datp, 271));
$header and out($heap,print_r($chDefSetup,true),$onscreen);
$uFncVarSet = dec_uFncVarSet(fread($datp, 569));
$header and out($heap,print_r($uFncVarSet,true),$onscreen);
$sweepSetup = dec_sweepSetup(fread($datp, 310));
$header and out($heap,print_r($sweepSetup,true),$onscreen);
$constSetup = dec_constSetup(fread($datp, 251));
$header and out($heap,print_r($constSetup,true),$onscreen);
$meas_setup = dec_meas_setup(fread($datp, 123));
$header and out($heap,print_r($meas_setup,true),$onscreen);
$oSeqTrgSet = dec_oSeqTrgSet(fread($datp,  69));
$header and out($heap,print_r($oSeqTrgSet,true),$onscreen);
$analyssSet = dec_analyssSet(fread($datp,1571));
$header and out($heap,print_r($analyssSet,true),$onscreen);
$gDispSetup = dec_gDispSetup(fread($datp, 565));
$header and out($heap,print_r($gDispSetup,true),$onscreen);

#------
#Find which SMU for each VAR?
	$var1=0;
	while (($var1 < count($chDefSetup['SMU'])) and ($chDefSetup['SMU'][$var1]['fctn']!='Var1')) {
		$var1++;
	}
	if ($var1==count($chDefSetup['SMU']))
		unset($var1);
	isset($var1) and ( $verbose and out($verp,"VAR1 = SMU" . ($var1+1) . "\n", $onscreen));
	$var2=0;
	while (($var2 < count($chDefSetup['SMU'])) and ($chDefSetup['SMU'][$var2]['fctn']!='Var2')) {
		$var2++;
	}
	if ($var2==count($chDefSetup['SMU']))
		unset($var2);
	isset($var2) and ($verbose and out($verp,"VAR2 = SMU" . ($var2+1) . "\n",$onscreen));
	$var1p=0;
	while (($var1p < count($chDefSetup['SMU'])) and ($chDefSetup['SMU'][$var1p]['fctn']!="Var1'")) {
		$var1p++;
	}
	if ($var1p==count($chDefSetup['SMU']))
		unset($var1p);
	isset($var1p) and ($verbose and out($verp,"VAR1' = SMU" . ($var1p+1) . "\n",$onscreen));
#------


fseek($datp,6,SEEK_CUR);
$apd_mark = fread($datp,2);
$apd = fread($datp,16);
$apdok=1;
for($i=0;$i<4;$i++) {
	 $apdok = $apdok and (substr($datp,4*$i+3,1)==chr($i));
}
$apdok and ($verbose and out($verp,"This file as 'appended' data\n",$onscreen));
fseek($datp,36,SEEK_CUR);
$append = 1;
while ($append) {
	$mini_header[$apdnb] = dec_mini_header(fread($datp,(($apdok) ? 888 : 788)));
	$header and out($heap,print_r($mini_header[$apdnb],true),$onscreen);


	$nb_list=0;
	foreach($gDispSetup['list'] as $var) {
		empty($var) or $nb_list++;
	}
	if ($apdok) {
		out($txtp,"--------------------------------------------------------------------------\n",$onscreen);
       		out($txtp,sprintf(" Append # %d\n",$apdnb+1),$onscreen);
		out($txtp,compare_head($sweepSetup,$constSetup,$chDefSetup,$mini_header[$apdnb]),$onscreen);
		out($txtp,"--------------------------------------------------------------------------\n",$onscreen);
	}
	$append = 0;
	$mark = findNB($datp,$verp,$onscreen,$ver);
	$pasvar1 = ($mini_header[$apdnb]['var1']['max']-$mini_header[$apdnb]['var1']['min'])/$mini_header[$apdnb]['var1']['step'];
	if (isset($var2)) {
		$pasvar2 = ($mini_header[$apdnb]['var2']['max']-$mini_header[$apdnb]['var2']['min'])/$mini_header[$apdnb]['var2']['step'];
	} else {
		$pasvar2 = 0;
	}
	$compl=false;
	$verbose and out($verp,"pas var 1 : $pasvar1 - pas var 2 : $pasvar2\n",$onscreen);
	for ($j=0; $j<$pasvar2+1; $j++) :
		$cont = 0;
		if (isset($var2)) {
			out($txtp,"--------------------------------------------------------------------------\n",$onscreen);
			out($txtp,$chDefSetup['SMU'][$var2][($chDefSetup['SMU'][$var2]['mode']) . 'name'] . " = ",$onscreen);
			out($txtp,$j * $mini_header[$apdnb]['var2']['step'] + $mini_header[$apdnb]['var2']['min'] . $chDefSetup['SMU'][$var2]['mode'] . "\n",$onscreen);
			out($txtp,"--------------------------------------------------------------------------\n",$onscreen);
		}
		foreach($gDispSetup['list'] as $var) {
			empty($var) or out($txtp,$var . " (" . findUnit($var,$chDefSetup['SMU']) .")\t",$onscreen);
		}
		out($txtp,"\n",$onscreen);
		out($txtp,"--------------------------------------------------------------------------\n",$onscreen);
		for ($i=0; $i<=$pasvar1; $i++) {
	      		#Normalement, on a un float 64-bits, 'Not Rounded'
			out($txtp,$i * $mini_header[$apdnb]['var1']['step'] + $mini_header[$apdnb]['var1']['min'] ."\t",$onscreen);
			
			//attention la ligne du bas marche dans un cas et pas dans l autre...
			
			for ($k=0; $k < $nb_list-1; $k++) {  
				$test_mark = fread($datp, 2);
				if (!($compl) and ((substr($test_mark,0,1)==chr(2)) and (substr($test_mark,1,1)==substr($mark,1,1)))) {
					#Compliance reached
					$compl=true;
				}
				if ($compl) {
	                		fseek($datp,8,SEEK_CUR);
					$res = "compliance reached";
	                	} else {
					$res = sprintf("%.".$nbsignif."e",f64cvt(fread($datp,8)));
				}
				out($txtp,$res . "\t",$onscreen);
			}
			out($txtp,"\n",$onscreen);  
	}
		$compl=false;
		$verbose and out($verp,"End position : " . ftell($datp) . "\n",$onscreen);
		$test = fread($datp,2);
		if (substr($test,1,1)==substr($mark,1,1)) {
			#les points sont a la suite.
			$verbose and out($verp,"Data is continue\n",$onscreen);
			$cont = 1;
			fseek($datp,-2,SEEK_CUR);
		} else {
	         	fseek($datp,8,SEEK_CUR);
			$test2 = fread($datp,2);
			fseek($datp,-12,SEEK_CUR);
			if ($test2!=$mark) {
				#Il y a un autre bloc 0..0 FFF[0E] 0..0 7FF[0E] 0..0
				$verbose and out($verp,"Another bloc FFF[0E]...7FF[0E]\n",$onscreen);
				$mark=findNB($datp,$verp,$onscreen,$ver);
			}
		}
	endfor;


	#Is there still an append ?
	while ((fread($datp,2)!=$apd_mark) and (ftell($datp)<$stats['size']));
	if (ftell($datp)<$stats['size']) {
		$append=1;
		$apdnb++;
		fseek($datp,52,SEEK_CUR);
	}
} #End of while for 'Append'



fclose($datp);
fclose($txtp);
$header and fclose($heap);
$verbose and fclose($verp);
$duration = microtime(true)-$start_time;
print "Execution time : ". $duration ."\n";

?>
