<?php

include ("fonctions.php");
include ("racine.php");

$tronctxt=""; 

// wafer, sample and device
$wafer_description=$_POST['wafer_description'];
$wafer=$_POST['wafer'];
$sample=$_POST['sample'];
$device=$_POST['device'];
$tronc=array($wafer,$sample,$device);

$device_description=$_POST['device_description'];
// directory path
$defautinputok=$_POST['defaultaq'];

if ($defautinputok==true){$dir_input="A:\\";}
else{$dir_input=$_POST['acqpath'];} 

// temperature and vd
$temp=$_POST['temperature'];
$vd=$_POST['Vd'];
$testvd=isset($_POST['Vd']);

if (isset($_POST['Vd'])){$Tvd=array($temp,$vd);} else {$Tvd=array($temp);}

$troncheader=$wafer_description.",".$wafer.",".$sample.",".$device_description.",Vd_".$vd.",T_".$temp.",R_";

for ($i=0;$i<$nbmaxupload;$i++)
{
	$Ri='R'.$i;
	$gaini='gain'.$i;
	$Vgi='Vg'.$i;
	$Voutdi='Voutd'.$i;
	$Vouti='Vout'.$i;
	$specbegi='specbeg'.$i;
	$specendi='specend'.$i;
	$timebegi='timebeg'.$i;
	$timeendi='timeend'.$i;
	$commenti='comment'.$i;
	
	if (isset($_POST[$Ri]) && ($_POST[$Ri]))	{$R[$i-1]=$_POST[$Ri];	}
	if (isset($_POST[$gaini]) && ($_POST[$gaini]))	{$gain[$i-1]=$_POST[$gaini];	}
	if (isset($_POST[$Vgi]) && ($_POST[$Vgi]))	{$Vg[$i-1]=$_POST[$Vgi];	}
	if (isset($_POST[$Voutdi]) && ($_POST[$Voutdi]))	{$Voutd[$i-1]=$_POST[$Voutdi];	}
	if (isset($_POST[$Vouti]) && ($_POST[$Vouti]))	{$Vout[$i-1]=$_POST[$Vouti];	}
	if (isset($_POST[$specbegi]) && ($_POST[$specbegi]))	{$specbeg[$i-1]=$_POST[$specbegi];	}
	if (isset($_POST[$specendi]) && ($_POST[$specendi]))	{$specend[$i-1]=$_POST[$specendi];	}
	if (isset($_POST[$timebegi]) && ($_POST[$timebegi]))	{$timebeg[$i-1]=$_POST[$timebegi];	}
	if (isset($_POST[$timeendi]) && ($_POST[$timeendi]))	{$timeend[$i-1]=$_POST[$timeendi];	}
	if (isset($_POST[$commenti]) && ($_POST[$commenti]))	{$comment[$i-1]=$_POST[$commenti];	}
}


// which data to treat
$dtok=isset($_POST['dt']);
$tpok=isset($_POST['tp']);
$datok=isset($_POST['dat']);

//add on to distinguish between spectrum and time measurements
$addtime='tp';


set_time_limit(500);
	
// on cree toute l arborescence:

chkandbuildpath(RACINEEXPS,$tronc,true);
$dir_output=buildpathstringarray(RACINEEXPS,$tronc);
chkandbuildpath($dir_output,$listdirdata,false);

chkandbuildpath($dir_output."\\graphs",$listgraph,false);
chkandbuildpath($dir_output."\\graphs\\jpg",$listgraphdata,false);
chkandbuildpath($dir_output."\\graphs\\wmf",$listgraphdata,false);


$listforsubfd=$listdirdata2;

if (!$tpok){array_splice ($listforsubfd, 8, 4);}
if (!$dtok){array_splice ($listforsubfd, 4, 4);}
if (!$datok){array_splice ($listforsubfd, 0, 4);}


for($i=0;$i<count($listforsubfd);$i++)
{
	$go=FALSE;

	$racinedata=buildpathstring($dir_output,$listforsubfd[$i]);
	chkandbuildpath($racinedata,$Tvd,true);

	if($listforsubfd[$i]=="tp"){	$racinedataextra=buildpathstringarray($racinedata,$Tvd); $go=TRUE;}
	if($listforsubfd[$i]=="tptxt"){	$racinedataextra=buildpathstringarray($racinedata,$Tvd); $go=TRUE;}

	if($listforsubfd[$i]=="graphs\\jpg\\time"){	$racinedataextra=buildpathstringarray($racinedata,$Tvd); $go=TRUE;}
	if($listforsubfd[$i]=="graphs\\wmf\\time"){	$racinedataextra=buildpathstringarray($racinedata,$Tvd); $go=TRUE;}
	
	if ($buildsubdirRok  && $go)	{ chkandbuildpath($racinedataextra,$R,false);	}
}

$originfilename=$wafer."_".$sample."_".$device.".opj";
$originfolder=$dir_output."\\"."origin";
$originprojectadress=$originfolder."\\".$originfilename;

if (! file_exists($originprojectadress)) 
{
		copy( "neworigin.opj",$originprojectadress);   
}

$dtfolder=$dir_output."\\dt\\".$temp."\\".$vd."\\";
$dttxtfolder=$dir_output."\\dttxt\\".$temp."\\".$vd."\\";
$tpfolderbase=$dir_output."\\tp\\".$temp."\\".$vd."\\";
$tptxtfolderbase=$dir_output."\\tptxt\\".$temp."\\".$vd."\\";

//start a shell command invisible in the background:

$WshShell = new COM("WScript.Shell");

for ($j=0;$j<count($R);$j++)
{
	$color=$j;
	//dt
	if ($dtok && isset($specbeg[$j]))
	{
		for ($i=$specbeg[$j];$i<=$specend[$j];$i++)
		{
			$type=$i-$specbeg[$j];

			$filename=$i.".DT";
			copy($dir_input.$filename,$dtfolder.$filename);

			$initialpath=$dtfolder.$filename;
			$finalpath=$dttxtfolder.$i.".txt";

			$line='c:\\progra~1\\easyphp1-7\\www\\exec\\sdftoasc '.$initialpath.' '.$finalpath.' /X /T:M /Y:PDR';
			$oExec = $WshShell->Run($line,0,true); 
			
			$header=$troncheader.$R[$j]."Ohm,G_1e".$gain[$j].",Id_".getid($vd,$R[$j]).",num_".$i.",".date("y-m-d").",col_".$color.",type_".$type;

			insertheader($finalpath,$header);

			$newname=$dttxtfolder."dt".$i."T".$temp.$vd.".txt";
			rename( $finalpath,$newname);

		}
	}

	//tp
	if ($tpok && isset($timebeg[$j]))
	{
		for ($i=$timebeg[$j];$i<=$timeend[$j];$i++)
		{
			$filename=$i.".TP";
			copy($dir_input.$filename,$tpfolderbase.$R[$j]."\\".$filename);
			
			$initialpath=$tpfolderbase.$R[$j]."\\".$filename;
			$finalpath=$tptxtfolderbase.$R[$j]."\\".$i.".txt";

			$line='c:\\progra~1\\easyphp1-7\\www\\exec\\sdftoasc '.$initialpath.' '.$finalpath.' /X  /Y:L';
			$oExec = $WshShell->Run($line,0,true); 

			$header=$troncheader.$R[$j]."Ohm,G_1e".$gain[$j].",Id_".getid($vd,$R[$j]).",num_".$i.",".date("y-m-d");

			insertheader($finalpath,$header);

			$newname=$tptxtfolderbase.$R[$j]."\\"."tp".$i."T".$temp.$vd.".txt";
			rename( $finalpath,$newname);

		}
	}

}
$formuleogs="mkdirnoise(\"".$temp."\",\"".$vd."\",\"";
for($i=0;$i<count($R);$i++){$formuleogs.=$R[$i].",";}
$formuleogs.="\");<br>cd(/freq/".$temp."/".$vd.");<br>SI;<br>cd(/time/".$temp."/".$vd.");<br>ITsubdir;";
echo($formuleogs);

?>