<?php

function chkandbuilddir($racine,$dirname)
{
			$path=buildpathstring($racine,$dirname);
			$dh  = @opendir($path);
			if (!$dh){mkdir($path,'0777');}
}


function chkandbuildpath($racine,$arborescence,$vertical)
{
		$path=$racine;
		
		foreach ($arborescence as $name) 
		{
			chkandbuilddir($path,$name);

			if ($vertical){$path=buildpathstring($path,$name);}
		}
}

function buildpathstring($racine,$name)
{
			$path=$racine."\\".$name;
			return($path);
}

function buildpathstringarray($racine,$arborescence)
{
		$path=$racine;

		foreach ($arborescence as $name) 
		{
			$path=buildpathstring($path,$name);
		}
		return($path);

}

/*function fillarray($T,$specfrom,$specto,$tpfrom,$tpto,$gain,$R)
{
	for ($i=$from;$i<=$to;$i++)
	{
		$T['dt']=$i;
	}
	return $T
}*/

function getid($vd,$res)
{
		// vd

	$pos = strpos($vd, 'm');
	$pos2=strpos($vd,'V');
	if($pos!=FALSE)
	{
		$v=substr($vd,0,$pos);
		$v=$v/1000;
	}
	elseif($pos2!=FALSE)
	{
		$v=substr($vd,0,$pos2);
		$v=$v*1;
	}

		//R
	$pos = strpos($res, 'k');
	$pos2 = strpos($res, 'M');
	$pos3 = strpos($res, 'G');
	if($pos!=FALSE)
	{
		$r=substr($res,0,$pos);
		$r=$r*1000;
	}
	elseif($pos2!=FALSE)
	{
		$r=substr($res,0,$pos2);
		$r=$r*1000000;
	}
	elseif($pos3!=FALSE)
	{
		$r=substr($res,0,$pos3);
		$r=$r*1000000000;
	}
	
	$id=$v/$r;

	if(($id*1000)>=1){$id=$id*1000;$idstr= sprintf("%01.0fmA", $id);}
	elseif(($id*1E6)>=1){$id=$id*1E6;$idstr= sprintf("%01.0fuA", $id);}
	elseif(($id*1E9)>=1){$id=$id*1E9;$idstr= sprintf("%01.0fnA", $id);}
	elseif(($id*1E12)>=1){$id=$id*1E12;$idstr= sprintf("%01.0fpA", $id);}
	elseif(($id*1E15)>=1){$id=$id*1E15;$idstr= sprintf("%01.0ffA", $id);}


	return($idstr);
}

function insertheader($file,$header,$modifdata)
{
	if (!file_exists($file)) touch($file);
	$fh = fopen($file, "r");
	
	if($modifdata=="itrts"||$modifdata=="frequency")
	{
		$towrite="$header\r\n";	
		$fcontent=file($file);
		for($j=0;$j<count($fcontent);$j++)
		{
			$modif="";
			if($modifdata=="itrts")
			{
				$line = explode(" ", $fcontent[$j]);
				if($line[2]>=0)
				{
					$line2=@explode("  ",$fcontent[$j]);
				    $line[2]=$line2[1];
				}
				$modif.=sprintf("%3e",$line[1])."\t".sprintf("%3e",trim($line[2]))."\r\n";
			}
			if($modifdata=="frequency"){$line = explode("  ", $fcontent[$j]);
			$modif.=sprintf("%3e",$line[0])."\t".sprintf("%3e",$line[1])."\r\n";}
			$towrite.=$modif;
		}
	}
	else
	{
		$fcontent = fread($fh, filesize($file));
		$towrite = "$header\r\n$fcontent";
	}
	fclose($fh);

	$fh2 = fopen($file, 'w+');
	fwrite($fh2, $towrite);
	fclose($fh2);
}

function getvar1var2($lines)
{
	$continue=TRUE;
	$numappend=0;

	global $num,$var1,$var2;
	
	while($continue)
	{
		$continue=FALSE;
		
		$var1[$numappend]['ok']=FALSE;
		
		$ligne2 = explode(",", $lines[$num]);
		$pos = strpos($ligne2[0], '=');

		if($pos!=FALSE) // there is a var 1
		{
			$var1[$numappend]['ok']=TRUE;
			$var1[$numappend]['name']=trim(substr($ligne2[0],0,$pos));
			$var1[$numappend]['beg']=trim($ligne2[1]);
			$var1[$numappend]['end']=trim($ligne2[3]);
			$var1[$numappend]['step']=trim($ligne2[5]);
			$var1[$numappend]['nb']=(($var1[$numappend]['end']-$var1[$numappend]['beg'])/$var1[$numappend]['step'])+1;

			$num++;
		}

		$var2[$numappend]['ok']=FALSE;
		$var2[$numappend]['nb']=1;

		$ligne3 = explode(",",$lines[$num]);
		$pos = strpos($ligne3[0], '=');
		

		if($pos!=FALSE) // there is a var 2
		{
			$var2[$numappend]['ok']=TRUE;
			$var2[$numappend]['name']=trim(substr($ligne3[0],0,$pos));
			$var2[$numappend]['beg']=trim($ligne3[1]);
			$var2[$numappend]['end']=trim($ligne3[3]);
			$var2[$numappend]['step']=trim($ligne3[5]);
			$var2[$numappend]['nb']=(($var2[$numappend]['end']-$var2[$numappend]['beg'])/$var2[$numappend]['step'])+1;
			
			$num++;
		}

		if(strpos($lines[$num],"/*")!=FALSE) // If there is an Append (or comment), we must jump this line
		{
			$num++; 
			$numappend++;
			$continue=TRUE;
		}
	}
	return($numappend);
}

function gotonextblock($lines)
{
	global $num,$var1,$var2;

	$continue=TRUE;
	while ($continue)
	{
		if(strpos($lines[$num],"NO")!==FALSE)
		{
			$continue=FALSE;
		}
		else
		{
			$num++;
		}
	}
}

function convertfile($filename,$inputfolder,$outputfolder)
{
	// get contents of a file into a string

	$fileadress =$inputfolder."\\".$filename;
	$troncfilenamearray=explode(".",$filename);
	$troncfilename=$troncfilenamearray[0];


	$lines = file($fileadress);

	global $num,$var1,$var2;
	
	$num=0; $nbappend=0;
	$comment =rtrim( $lines[$num]); $num++;
	
	$nbappend=getvar1var2($lines)+1;


	/*******************************************************************************
	***********************  DATAS  ***********************************************
	*******************************************************************************/
	for($i=0;$i<$nbappend;$i++)
	{
		if($i==0)	{$filenameend = $outputfolder."\\".$troncfilename.".txt";}
		else {$filenameend = $outputfolder."\\".$troncfilename."ap".$i.".txt";}

		gotonextblock($lines);

		$ligne = explode(",", $lines[$num]); // variables name
		$num++;
		$Y=trim($ligne[2]); // basic case Y is 3rd column

		$num++; // unit line


		for($j=0;$j<$var2[$i]['nb'];$j++)
		{
			for($k=0;$k<$var1[$i]['nb'];$k++)
			{
				$ligne = explode(",", $lines[$num]); $num++;
				$dataY[$k][$j]=trim($ligne[2]); // basic case Y is 3rd column
			}
		}

		$latspacer="\t";
		$vertspacer="\r\n";

		$fend=$comment.$vertspacer;
		$fend.="template_iv";

		$colnames="";
		if($var2[$i]['nb']>1)
		{
			for ($j=0;$j<$var2[$i]['nb'];$j++)
			{
				$var2value=$var2[$i]['beg']+$j*$var2[$i]['step'];
				if($var2value<0){$var2value=abs($var2value);$var2value="m".$var2value;}
				$fend.=",col_".$Y.$var2value."_".$j."_0_-1";
				$colnames.=$latspacer.$Y.$var2value;
			}
		}
		else
		{
			$fend.=",col_".$Y."0_0_-1";
			$colnames.=$latspacer.$Y;
		}

		$fend.=$vertspacer.$var1[$i]['name'];
		$fend.=$colnames;

		$fend.=$vertspacer.$var1[$i]['name'];
		if($var2[$i]['nb']>1)
		{
			for ($j=0;$j<$var2[$i]['nb'];$j++)
			{
				$var2value=$var2[$i]['beg']+$j*$var2[$i]['step'];
				$fend.=$latspacer.$var2[$i]['name']."=".$var2value;
			}
		}
		else
		{
			$fend.=$latspacer.$Y;
		}

		for($k=0;$k<$var1[$i]['nb'];$k++)
		{
			$fend.=$vertspacer;
			$X=$var1[$i]['beg']+$k*$var1[$i]['step'];
			$fend.=$X;

			for($j=0;$j<$var2[$i]['nb'];$j++)
			{
				$fend.=$latspacer.$dataY[$k][$j];
			}
		}

		$fh2 = fopen($filenameend, 'w+');
		fwrite($fh2, $fend);
		fclose($fh2);
	}
}

// return all the files with a given extension in an array
function getfilesfromdir($inputfolder,$extension) 
{
	$files=array();
	if($handle=opendir($inputfolder))
	{
		while(false!==($file=readdir($handle)))
		{
			if(strstr($file,$extension))
			{
				$files[]=$file;
			}
		}
	}
	return($files);
}

function copyfromdirtodir($inputfolder,$outputfolder,$extension)
{
	$files=getfilesfromdir($inputfolder,$extension);
	
	for($i=0;$i<sizeof($files);$i++)
	{
		$inputfileadress=$inputfolder."\\".$files[$i];
		$outputfileadress=$outputfolder."\\".$files[$i];
		copy($inputfileadress,$outputfileadress);
	}
}

function convertfromdirtodir($inputfolder,$outputfolder)
{
	$files=getfilesfromdir($inputfolder,".txt");
	for($i=0;$i<sizeof($files);$i++)	{convertfile($files[$i],$inputfolder,$outputfolder);	}
	$files=getfilesfromdir($inputfolder,".TXT");
	for($i=0;$i<sizeof($files);$i++)	{convertfile($files[$i],$inputfolder,$outputfolder);	}
}

?>