<?php
$name='A';
$finname="8K100d";
$labely="PowerV2rmsHz";#000066#33CCFF
$xmin=0.7;
$xmax=100000;
$ymin=1e-26*1e16;
$ymax=1e-19*1e16;
$nbcourbes=3;
$noaxis=1;
$nogain=1;
$nocolor=0;
$nominindice=1;

$minindice[0]=33; //8000
$minindice[1]=26; //800
$minindice[2]=51; //200
$minindice[3]=41; //20 (41)
$minindice[4]=1; //debut

$debut[0]=5;
$fin[0]=8;
$gain[0]=10000;
$color[0]=1;

$debut[1]=9;
$fin[1]=12;
$gain[1]=100;
$color[1]=2;


$debut[2]=25;
$fin[2]=28;
$gain[2]=100;
$color[2]=3;

$debut[3]=33;
$fin[3]=36;
$gain[3]=1;
$color[3]=4;

$debut[4]=53;
$fin[4]=56;
$gain[4]=100;
$color[4]=5;

$debut[5]=53;
$fin[5]=56;
$gain[5]=1;
$color[5]=5;

$debut[6]=25;
$fin[6]=28;
$gain[6]=0.01;
$color[6]=6;

$debut[7]=29;
$fin[7]=32;
$gain[7]=0.0001;
$color[7]=8;

$debut[8]=33;
$fin[8]=36;
$gain[8]=0.0001;
$color[8]=9;

$debut[9]=37;
$fin[9]=40;
$gain[9]=0.000001;
$color[9]=10;

$debut[10]=41;
$fin[10]=44;
$gain[10]=0.000001;
$color[10]=11;

$instruction='';

if ($noaxis!=1) {$instruction.='X1='.$xmin.'; X2='.$xmax.'; Y1='.$ymin.'; Y2='.$ymax.';<br>';}

for ($j=0;$j<$nbcourbes;$j++)
{
	for ($i=$debut[$j];$i<=$fin[$j];$i++)
	{
		if ($nogain!=1) {$instruction.=$name.$i.$finname.'_'.$labely.'='.$name.$i.$finname.'_'.$labely.'*'.$gain[$j].';<br>';}
		if ($nocolor!=1) {$instruction.='set '.$name.$i.$finname.'_'.$labely.' -c '.$color[$j].';<br>';}
		if ($nominindice!=1) 
		{
			if($i!=$fin[$j])
			{
				$instruction.='set '.$name.$i.$finname.'_'.$labely.' -b '.$minindice[($i-$debut[$j])].';<br>';
				$instruction.='<br>';
			}
		}
	}
	$instruction.='<br>';
}
echo $instruction;

?>