<?php
$name='C';
$finname="28K50";
$labely="PowerV2rmsHz";
$xmin=0.7;
$xmax=100000;
$ymin=1e-26*1e16;
$ymax=1e-19*1e16;
$nbcourbes=12;
$noaxis=0;
$nogain=0;
$nocolor=0;
$nominindice=0;

$minindice[0]=33; //8000
$minindice[1]=26; //800
$minindice[2]=51; //200
$minindice[3]=41; //20 (41)
$minindice[4]=1; //debut

$debut[0]=1;
$fin[0]=5;
$gain[0]=9;  
$color[0]=12;

$debut[1]=6;
$fin[1]=10;
$gain[1]=9;
$color[1]=11;

$debut[2]=11;
$fin[2]=15;
$gain[2]=9;
$color[2]=10;

$debut[3]=16;
$fin[3]=20;
$gain[3]=9; 
$color[3]=9;

$debut[4]=21;
$fin[4]=25;
$gain[4]=8; 
$color[4]=8;

$debut[5]=26;
$fin[5]=30;
$gain[5]=8; 
$color[5]=7;

$debut[6]=31;
$fin[6]=35;
$gain[6]=7;
$color[6]=6;

$debut[7]=36;
$fin[7]=40;
$gain[7]=7;
$color[7]=5;

$debut[8]=41;
$fin[8]=45;
$gain[8]=6; 
$color[8]=4;

$debut[9]=46;
$fin[9]=50;
$gain[9]=6;
$color[9]=3;

$debut[10]=51;
$fin[10]=55;
$gain[10]=6;
$color[10]=2;

$debut[11]=56;
$fin[11]=60;
$gain[11]=6;
$color[11]=1;

$debut[12]=49;
$fin[12]=52;
$gain[12]=0.0001; 
$color[12]=13;

$debut[13]=53;
$fin[13]=56;
$gain[13]=0.000001;
$color[13]=14;
$instruction='';

if ($noaxis!=1) {$instruction.='X1='.$xmin.'; X2='.$xmax.'; Y1='.$ymin.'; Y2='.$ymax.';<br>';}

for ($j=0;$j<$nbcourbes;$j++)
{
	for ($i=$debut[$j];$i<=$fin[$j];$i++)
	{
		$gain2=2*$gain[$j];
		if ($nogain!=1) {$instruction.=$name.$i.$finname.'_'.$labely.'='.$name.$i.$finname.'_'.$labely.'*1E-'.$gain2.';<br>';}
		if ($nocolor!=1) {$instruction.='set '.$name.$i.$finname.'_'.$labely.' -c '.$color[$j].';<br>';}
		if ($nominindice!=1) 
		{
			if($i!=$fin[$j])
			{
				$instruction.='set '.$name.$i.$finname.'_'.$labely.' -b '.$minindice[($i-$debut[$j])].';<br>';
				$instruction.='<br>';
			}
		}
	}
	$instruction.='<br>';
}
echo $instruction;

?>